<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Load Constant Instructions</TITLE>
<link href="suif1_35.html" rel=Next>
<link href="suif1_33.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_33.html">previous</A>, <A HREF="suif1_35.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC34" HREF="suif1_toc.html#TOC34">Load Constant Instructions</A></H2>
<P>
<A NAME="IDX204"></A>
<A NAME="IDX205"></A>

</P>
<P>
<A NAME="IDX206"></A>
<A NAME="IDX207"></A>
<A NAME="IDX208"></A>
Rather than allowing constant values to be used directly as operands,
SUIF uses separate <CODE>ldc</CODE> instructions to load constant values.  The
<CODE>in_ldc</CODE> class holds these instructions.  Instead of the usual
source operands, this class has an immediate value field
(see section <A HREF="suif1_100.html#SEC100">Immediate Values</A>).  The <CODE>value</CODE> and <CODE>set_value</CODE> methods may be
used to access this field.

</P>
<P>
Only certain kinds of immediate values are supported in an <CODE>ldc</CODE>
instruction:

</P>
<DL COMPACT>

<DT>Symbolic addresses (See section <A HREF="suif1_101.html#SEC101">Symbolic Addresses</A>)
<DD>
The result type of the instruction must be a pointer type.

<DT>Integers
<DD>
The result type must be an integer or pointer type.  Pointer types are
allowed so that the null pointer can be loaded as the integer value
zero.

<DT>Floating-point values
<DD>
The result type must be a floating-point type.
</DL>

<P>
Other kinds of immediate values may be stored in the <CODE>value</CODE> field
of an <CODE>ldc</CODE> instruction, but most SUIF passes and certain library
functions will not be able to handle them.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_33.html">previous</A>, <A HREF="suif1_35.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
